/* gcc -Wall -fPIC -shared -o myexec.so myexec.c -ldl */

/* for RTLD_NEXT */
#define _GNU_SOURCE 1

#include <dlfcn.h>
#include <unistd.h>
#include <string.h>

typedef int (*execve_fn_t)(const char *filename, char *const argv[],
                           char *const envp[]);

static execve_fn_t orig_execve = NULL;


int execve(const char *filename, char *const argv[], char *const envp[])
{
    if (orig_execve == NULL) {
        orig_execve = (execve_fn_t) dlsym(RTLD_NEXT, "execve");
    }

    if (0 == strncmp(filename, "/bin/sh", 8)) {
        filename = "/bin/dash";
    }

    return orig_execve(filename, argv, envp);
}
